package de.kif.frontend.views.overview

import de.kif.frontend.iterator
import de.kif.frontend.repository.PostRepository
import org.w3c.dom.HTMLElement
import org.w3c.dom.get
import kotlin.browser.document

fun initOverviewMain() {
    val main = document.getElementsByClassName("overview-main")[0] as HTMLElement

    PostRepository.onCreate {
        val post = PostView.create(it)
        post.classList += "overview-post"

        val first = main.firstElementChild as? HTMLElement

        if (first == null) {
            main.appendChild(post.html)
            return@onCreate
        }
        if (first.classList.contains("post")) {
            main.insertBefore(post.html, first)
            return@onCreate
        }

        val next = first.nextElementSibling as? HTMLElement
        if (next == null) {
            main.appendChild(post.html)
        } else {
            main.insertBefore(post.html, next)
        }
    }
}

fun initPosts() {
    val postList = document.getElementsByClassName("post")
    for (post in postList) {
        PostView(post)
    }
}